angular.module('ptv.services', [])

.service('api', function($http, ApiEndpoint) {
    var service = this;
    var basicAuth = 'Basic YXZsOmFkczgyM2hybGFkazIwZGhuZmwxJGU0dWp0';

    service.simpleSearch = function(word) {
        var url = ApiEndpoint.url + '/buscasimple/' + encodeURIComponent(word) + "?origen=ptv";
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.interconexio = function(word) {
        var url = ApiEndpoint.url + '/interconexio/' + encodeURIComponent(word) + "?origen=ptv";
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.simpleSearchLevenshtein = function(word) {
        var url = ApiEndpoint.url + '/buscasimple_lev/' + encodeURIComponent(word);
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.wordByDefinition = function(idDef) {
        var url = ApiEndpoint.url + '/paraulabydef/' + idDef + "?origen=ptv";
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.wordByDefinitionDNV = function(idDef) {
        var url = ApiEndpoint.url + '/paraulabydef/' + idDef;
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.gramaticalCategories = function() {
        var url = ApiEndpoint.url + '/catgramlexvals?origen=ptv';
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.languageLevels = function() {
        var url = ApiEndpoint.url + '/nivllenguas?origen=ptv';
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.languageOrigins = function() {
        var url = ApiEndpoint.url + '/llenguaos?origen=ptv';
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.intentions = function() {
        var url = ApiEndpoint.url + '/catsemanticas?origen=ptv';
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.thematicAreas = function() {
        var url = ApiEndpoint.url + '/temesCombo?origen=ptv';
        return $http({
            method: 'GET',
            url: url,
            headers: {
                'Authorization' : basicAuth
            }
        });
    }

    service.proposal = function(data) {
        var url = ApiEndpoint.url + '/sendMail';
        return $http({
            method: 'POST',
            url: url,
            data: data,
            headers: {
                'Content-Type': 'application/json',
                'Accept': 'application/json',
                'Authorization' : basicAuth
            }
        });
    }

    service.advancedSearch = function(page, offset, data) {
        var url = ApiEndpoint.url + '/paraulacriterios/' + page + '/' + offset + "?origen=ptv";
        return $http({
            method: 'POST',
            url: url,
            data: data,
            headers: {
                'Content-Type': 'application/json',
                'Accept': 'application/json',
                'Authorization' : basicAuth
            }
        });
    }

    service.definitions = function(pkey, data) {
        var url = ApiEndpoint.url + '/definicio/' + pkey + "?origen=ptv";
        return $http({
            method: 'POST',
            url: url,
            data: data,
            headers: {
                'Content-Type': 'application/json',
                'Accept': 'application/json',
                'Authorization' : basicAuth
            }
        });
    }

    service.log = function(data) {
        var url = ApiEndpoint.url + '/log?origen=ptv';
        return $http({
            method: 'POST',
            url: url,
            data: data,
            headers: {
                'Content-Type': 'application/json',
                'Accept': 'application/json',
                'Authorization' : basicAuth
            }
        });
    }

})

.service('historial', function($rootScope) {
    var service = this;

    service.add = function(word) {
        if ($rootScope.historial == null) $rootScope.historial = [];
        if ($rootScope.historial.length > 0) {
            var index = $rootScope.historial.indexOf(word);
            if (index > -1) $rootScope.historial.splice(index, 1);
        }
        $rootScope.historial.push(word);
    }

    service.retrieve = function() {
        if ($rootScope.historial == null) $rootScope.historial = [];
        return $rootScope.historial;
    }

})

.service('dropDowns', function($rootScope, $q, api) {
    var service = this;

    $rootScope.infoDropDowns = {
        isLoaded: false,
        criterias: [
            { value: "1", text: "Comença" },
            { value: "2", text: "Conté" },
            { value: "3", text: "Acaba" }
        ],
        thematicAreas: [],
        gramaticalCategories: [],
        languageLevels: [],
        languageOrigins: [],
        intentions: []
    }

    function checkEmptyOption(array) {
        if (array != null && (array.length > 0 && (array[0] == ""))) {
            array.splice(0, 1);
        }
        return array;
    }

    service.load = function() {
        var deferred = $q.defer();
        var queries = [];

        if ($rootScope.infoDropDowns.thematicAreas.length == 0)  {
            queries.push(
                api.thematicAreas().then(function(result) {
                    for (var i = 0; i < result.data.length; i++) {
                        var ta = result.data[i];
                        if (ta.tema != null) {
                            var index = $rootScope.infoDropDowns.thematicAreas.indexOf(ta.tema);
                            if (index < 0) {
                                $rootScope.infoDropDowns.thematicAreas.push(ta.tema);
                            }
                        }
                    }
                    $rootScope.infoDropDowns.thematicAreas = checkEmptyOption($rootScope.infoDropDowns.thematicAreas);
                })
            );
        }

        if ($rootScope.infoDropDowns.gramaticalCategories.length == 0)  {
            queries.push(
                api.gramaticalCategories().then(function(result) {
                    for (var i = 0; i < result.data.length; i++) {
                        var gc = result.data[i];
                        if (gc.duplatabla != null && gc.duplatabla.dnv != null) {
                            var index = $rootScope.infoDropDowns.gramaticalCategories.indexOf(gc.duplatabla.dnv);
                            if (index < 0) {
                                $rootScope.infoDropDowns.gramaticalCategories.push(gc.duplatabla.dnv);
                            }
                        }
                    }
                    $rootScope.infoDropDowns.gramaticalCategories = checkEmptyOption($rootScope.infoDropDowns.gramaticalCategories);
                })
            );
        }

        if ($rootScope.infoDropDowns.languageOrigins.length == 0)  {
            queries.push(
                api.languageOrigins().then(function(result) {
                    for (var i = 0; i < result.data.length; i++) {
                        var lo = result.data[i];
                        if (lo.llenguaorigen != null) {
                            var index = $rootScope.infoDropDowns.languageOrigins.indexOf(lo.llenguaorigen);
                            if (index < 0) {
                                $rootScope.infoDropDowns.languageOrigins.push(lo.llenguaorigen);
                            }
                        }
                    }
                    $rootScope.infoDropDowns.languageOrigins = checkEmptyOption($rootScope.infoDropDowns.languageOrigins);
                })
            );
        }

        $q.all(queries).then(function() {
            $rootScope.infoDropDowns.isLoaded = true;
            deferred.resolve();
        });

        return deferred.promise;
    }
})

.service('searchBack', function() {
    this.word = null;
    this.newSearch = false;
})

.service('goToSearch', function() {
    this.word = null;
    this.search = false;
})

.service('openSibling', function() {

    var service = this;

    service.openWord = function(word) {
        word = word.split(/[ \-\']/)[0];
        launchSibling("search=" + encodeURIComponent(word));
    }

    service.openPkey = function(pkey, acc) {
        launchSibling("pkey=" + pkey + "&acc=" + acc);
    }

    function launchSibling(parameters) {
        var appId, appStarter = "";
        if (ionic.Platform.isAndroid()) {
            // plugin com.lampa.startapp
            appId = 'es.ecran.avl.dnv';
            appStarter = startApp.set({
                package: appId,
                action: "ACTION_VIEW",
                uri: "avldnv://?" + parameters
            });
            appStarter.start(
                function(msg) {},
                function(err) {
                    window.open('market://details?id=' + appId, '_system');
                }
            );
        } else {
            if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
                appId = "avldnv://?" + parameters;
                appStarter = startApp.set(appId);
                appStarter.start(
                    function(msg) {},
                    function(err) {
                        window.open('itms-apps://itunes.apple.com/es/app/diccionari-normatiu-valencià/id942967321?mt=8', '_system');
                    }
                );
            }
        }
    }
});